/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

class Fr protected constructor(
    @field:Transient private var swigCPtr: Long,
    @field:Transient protected var swigCMemOwn: Boolean
) {
    protected fun finalize() {
        delete()
    }

    @Synchronized
    fun delete() {
        if (swigCPtr != 0L) {
            if (swigCMemOwn) {
                swigCMemOwn = false
                MclJNI.delete_Fr(swigCPtr)
            }
            swigCPtr = 0
        }
    }

    constructor() : this(MclJNI.new_Fr__SWIG_0(), true) {}
    constructor(rhs: Fr?) : this(MclJNI.new_Fr__SWIG_1(getCPtr(rhs), rhs), true) {}
    constructor(x: Int) : this(MclJNI.new_Fr__SWIG_2(x), true) {}
    constructor(str: String?, base: Int) : this(MclJNI.new_Fr__SWIG_3(str, base), true) {}
    constructor(str: String?) : this(MclJNI.new_Fr__SWIG_4(str), true) {}

    fun equals(rhs: Fr?): Boolean {
        return MclJNI.Fr_equals(swigCPtr, this, getCPtr(rhs), rhs)
    }

    val isZero: Boolean
        get() = MclJNI.Fr_isZero(swigCPtr, this)
    val isOne: Boolean
        get() = MclJNI.Fr_isOne(swigCPtr, this)

    fun setStr(str: String?, base: Int) {
        MclJNI.Fr_setStr__SWIG_0(swigCPtr, this, str, base)
    }

    fun setStr(str: String?) {
        MclJNI.Fr_setStr__SWIG_1(swigCPtr, this, str)
    }

    fun setInt(x: Int) {
        MclJNI.Fr_setInt(swigCPtr, this, x)
    }

    fun clear() {
        MclJNI.Fr_clear(swigCPtr, this)
    }

    fun setByCSPRNG() {
        MclJNI.Fr_setByCSPRNG(swigCPtr, this)
    }

    fun toString(base: Int): String? {
        return MclJNI.Fr_toString__SWIG_0(swigCPtr, this, base)
    }

    override fun toString(): String {
        return MclJNI.Fr_toString__SWIG_1(swigCPtr, this)!!
    }

    fun deserialize(cbuf: ByteArray?) {
        MclJNI.Fr_deserialize(swigCPtr, this, cbuf)
    }

    fun setLittleEndianMod(cbuf: ByteArray?) {
        MclJNI.Fr_setLittleEndianMod(swigCPtr, this, cbuf)
    }

    fun setHashOf(cbuf: ByteArray?) {
        MclJNI.Fr_setHashOf(swigCPtr, this, cbuf)
    }

    fun serialize(): ByteArray? {
        return MclJNI.Fr_serialize(swigCPtr, this)
    }

    companion object {
        fun getCPtr(obj: Fr?): Long {
            return obj?.swigCPtr ?: 0
        }
    }
}